local gui,axis,window = {}
local localPlayer = getLocalPlayer()
local axes = { "x","-x","y","-y" }

addEventHandler ( "onClientResourceStart", getResourceRootElement(getThisResource()),
	function()
		outputChatBox("Editor Loop generator started", 255,255,0 )
		outputChatBox("Use 'mloop' in console to bring up loop GUI.", 255,255,0 )
		--
		window = guiCreateWindow(100,100,300,360,"Loop Generator",false)
		guiWindowSetSizable ( window, false )
		guiSetVisible ( window, false )
		--
		guiCreateLabel ( 20, 20, 400, 16, "Position:",false,window)
		gui.x = guiCreateEdit ( 20, 40, 50, 23, "0", false, window )
		gui.y = guiCreateEdit ( 72, 40, 50, 23, "0", false, window )
		gui.z = guiCreateEdit ( 124, 40, 50, 23, "0", false, window )
		addEventHandler ( "onClientGUIClick", guiCreateButton ( 176, 40, 120, 23, "Dump from cam", false, window ),
			function()
				local x,y,z = getCameraMatrix()
				guiSetText ( gui.x, x )
				guiSetText ( gui.y, y )
				guiSetText ( gui.z, z )
			end,
		false )
		--
		guiCreateLabel ( 20, 70, 400, 16, "Initial Rotation:",false,window)
		gui.rx = guiCreateEdit ( 20, 90, 50, 23, "0", false, window )
		gui.ry = guiCreateEdit ( 72, 90, 50, 23, "0", false, window )
		gui.rz = guiCreateEdit ( 124, 90, 50, 23, "0", false, window )
		addEventHandler ( "onClientGUIClick", guiCreateButton ( 176, 90, 120, 23, "Dump from cam", false, window ),
			function()
				local px, py, pz, lx, ly, lz = getCameraMatrix()
				local rotz = 6.2831853071796 - math.atan2 ( ( lx - px ), ( ly - py ) ) % 6.2831853071796
				local rotx = math.atan2 ( lz - pz, getDistanceBetweenPoints2D ( lx, ly, px, py ) )
				guiSetText( gui.rx, math.deg(rotx) )
				guiSetText( gui.ry, "180" )
				guiSetText( gui.rz, math.deg(rotz) )
			end,
		false )
		--
		guiCreateLabel ( 20, 120, 400, 16, "Model:",false,window)
		gui.model = guiCreateEdit ( 20, 140, 50, 23, "18450", false, window )		
		--
		guiCreateLabel ( 20, 170, 400, 16, "Offset:",false,window)
		gui.offset = guiCreateEdit ( 20, 190, 50, 23, "20", false, window )
		--
		guiCreateLabel ( 90, 170, 50, 23, "Pieces:", false, window )
		gui.pieces = guiCreateEdit ( 90, 190, 50, 23, "50", false, window )
		--
		guiCreateLabel ( 160, 170, 50, 23, "Radius:", false, window )
		gui.radius = guiCreateEdit ( 160, 190, 50, 23, "40", false, window )		
		--
		guiCreateLabel ( 230, 170, 50, 23, "Loops:", false, window )
		gui.loops = guiCreateEdit ( 230, 190, 50, 23, "1", false, window )	
		--
		axis = guiCreateGridList ( 20, 240, 100, 100, false, window )
		guiGridListAddColumn ( axis, "Rotation axis", 0.8 )
		for i, axisName in ipairs(axes) do
			local row = guiGridListAddRow ( axis )
			guiGridListSetItemText ( axis, row, 1, axisName, false, false )
		end
		guiGridListSetSelectedItem ( axis, 3, 1 )
		--
		addEventHandler ( "onClientGUIClick", guiCreateButton ( 160, 280, 100, 23, "Generate!", false, window ),
			function()
				local values = {}
				for name,guiElement in pairs(gui) do
					values[name] = tonumber(guiGetText ( guiElement ))
					if not values[name] then
						outputChatBox ( "Could not create loop, bad '"..name.."' param" )
						return
					end
				end
				--Get axis
				local selectedItem = guiGridListGetSelectedItem ( axis )
				if selectedItem == -1 then
					outputChatBox ( "Could not create loop, bad 'rotation axis' param" )
					return
				end
				local axisName = guiGridListGetItemText ( axis, selectedItem, 1 )
				triggerServerEvent ( "doCreateLoop", localPlayer, localPlayer, false, 
					values.model, values.x, values.y, values.z, values.pieces, values.offset, values.radius, values.rx, values.ry, values.rz, axisName, values.loops, values.rz )
			end,
		false )
	end
)

addCommandHandler ( "mloop", function()	guiSetVisible(window, not guiGetVisible(window) ) end )